<center><a href="dscpack.c">Actual source code: dscpack.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:25:02+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/* </font>
<a name="line4">  4: </a><font color="#B22222">        Provides an interface to the DSCPACK (Domain-Separator Codes) sparse direct solver</font>
<a name="line5">  5: </a><font color="#B22222">*/</font>

<a name="line7"> 7: </a> #include <A href="../../../../../../src/mat/impls/baij/seq/baij.h.html">src/mat/impls/baij/seq/baij.h</A>
<a name="line8"> 8: </a> #include <A href="../../../../../../src/mat/impls/baij/mpi/mpibaij.h.html">src/mat/impls/baij/mpi/mpibaij.h</A>

<a name="line11"> 11: </a><font color="#A020F0">#include </font><font color="#666666">"dscmain.h"</font><font color="#A020F0"></font>

<a name="line14"> 14: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line15"> 15: </a>  DSC_Solver        My_DSC_Solver;
<a name="line16"> 16: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>      num_local_strucs, *local_struc_old_num,
<a name="line17"> 17: </a>                num_local_cols, num_local_nonz,
<a name="line18"> 18: </a>                *global_struc_new_col_num,
<a name="line19"> 19: </a>                *global_struc_new_num, *global_struc_owner,
<a name="line20"> 20: </a>                dsc_id,bs,*local_cols_old_num,*replication;
<a name="line21"> 21: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>      order_code,scheme_code,factor_type, stat,
<a name="line22"> 22: </a>                LBLASLevel,DBLASLevel,max_mem_allowed;
<a name="line23"> 23: </a>  <A href="../../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A>  flg;
<a name="line24"> 24: </a>  <A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A>            my_cols,iden,iden_dsc;
<a name="line25"> 25: </a>  <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>           vec_dsc;
<a name="line26"> 26: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatter.html#VecScatter">VecScatter</A>    scat;
<a name="line27"> 27: </a>  <A href="../../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A>      comm_dsc;

<a name="line29"> 29: </a>  <font color="#B22222">/* A few inheritance details */</font>
<a name="line30"> 30: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line31"> 31: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A>,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*);
<a name="line32"> 32: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>);
<a name="line33"> 33: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Mat/MatAssemblyType.html#MatAssemblyType">MatAssemblyType</A>);
<a name="line34"> 34: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactorSymbolic.html#MatCholeskyFactorSymbolic">MatCholeskyFactorSymbolic</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A>,<A href="../../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>*,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*);
<a name="line35"> 35: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>);
<a name="line36"> 36: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*MatPreallocate)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*);

<a name="line38"> 38: </a>  <font color="#B22222">/* Clean up flag for destructor */</font>
<a name="line39"> 39: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> CleanUpDSCPACK;
<a name="line40"> 40: </a>} Mat_DSC;

<a name="line42"> 42: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDuplicate_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A>,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line44"> 44: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_BAIJ_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,const <A href="../../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A>,<A href="../../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A>,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;

<a name="line47"> 47: </a><font color="#B22222">/* DSC function */</font>
<a name="line50"> 50: </a><strong><font color="#4169E1"><a name="isort2"></a>void isort2(<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>, <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *list, <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *idx_dsc)</font></strong> {
<a name="line51"> 51: </a>  <font color="#B22222">/* in increasing order */</font>
<a name="line52"> 52: </a>  <font color="#B22222">/* idx_dsc will contain indices such that */</font>
<a name="line53"> 53: </a>  <font color="#B22222">/* list can be accessed in sorted order */</font>
<a name="line54"> 54: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i, j, x, y;
<a name="line55"> 55: </a>
<a name="line56"> 56: </a>  <font color="#4169E1">for</font> (i=0; i&lt;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>; i++) idx_dsc[i] =i;

<a name="line58"> 58: </a>  <font color="#4169E1">for</font> (i=1; i&lt;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>; i++){
<a name="line59"> 59: </a>    y= idx_dsc[i];
<a name="line60"> 60: </a>    x=list[idx_dsc[i]];
<a name="line61"> 61: </a>    <font color="#4169E1">for</font> (j=i-1; ((j&gt;=0) &amp;&amp; (x&lt;list[idx_dsc[j]])); j--)
<a name="line62"> 62: </a>      idx_dsc[j+1]=idx_dsc[j];
<a name="line63"> 63: </a>    idx_dsc[j+1]=y;
<a name="line64"> 64: </a>  }
<a name="line65"> 65: </a>}<font color="#B22222">/*end isort2*/</font>

<a name="line69"> 69: </a><strong><font color="#4169E1"><a name="BAIJtoMyANonz"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  BAIJtoMyANonz( <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *AIndex, <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *AStruct, <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> bs,</font></strong>
<a name="line70"> 70: </a><strong><font color="#4169E1">                    RealNumberType *ANonz, <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> NumLocalStructs, </font></strong>
<a name="line71"> 71: </a><strong><font color="#4169E1">                    <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> NumLocalNonz,  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *GlobalStructNewColNum,                </font></strong>
<a name="line72"> 72: </a><strong><font color="#4169E1">                    <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *LocalStructOldNum,</font></strong>
<a name="line73"> 73: </a><strong><font color="#4169E1">                    <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *LocalStructLocalNum,</font></strong>
<a name="line74"> 74: </a><strong><font color="#4169E1">                    RealNumberType **adr_MyANonz)</font></strong>
<a name="line75"> 75: </a><font color="#B22222">/* </font>
<a name="line76"> 76: </a><font color="#B22222">   Extract non-zero values of lower triangular part</font>
<a name="line77"> 77: </a><font color="#B22222">   of the permuted matrix that belong to this processor.</font>

<a name="line79"> 79: </a><font color="#B22222">   Only output parameter is adr_MyANonz -- is malloced and changed.</font>
<a name="line80"> 80: </a><font color="#B22222">   Rest are input parameters left unchanged.</font>

<a name="line82"> 82: </a><font color="#B22222">   When LocalStructLocalNum == <A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,</font>
<a name="line83"> 83: </a><font color="#B22222">        AIndex, AStruct, and ANonz contain entire original matrix A </font>
<a name="line84"> 84: </a><font color="#B22222">        in PETSc SeqBAIJ format,</font>
<a name="line85"> 85: </a><font color="#B22222">        otherwise,</font>
<a name="line86"> 86: </a><font color="#B22222">        AIndex, AStruct, and ANonz are indeces for the submatrix</font>
<a name="line87"> 87: </a><font color="#B22222">        of A whose colomns (in increasing order) belong to this processor.</font>

<a name="line89"> 89: </a><font color="#B22222">   Other variables supply information on ownership of columns</font>
<a name="line90"> 90: </a><font color="#B22222">   and the new numbering in a fill-reducing permutation</font>

<a name="line92"> 92: </a><font color="#B22222">   This information is used to setup lower half of A nonzeroes</font>
<a name="line93"> 93: </a><font color="#B22222">   for columns owned by this processor</font>
<a name="line94"> 94: </a><font color="#B22222"> */</font>
<a name="line95"> 95: </a>{
<a name="line97"> 97: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>            i, j, k, iold,inew, jj, kk, bs2=bs*bs,
<a name="line98"> 98: </a>                 *idx, *NewColNum,
<a name="line99"> 99: </a>                 MyANonz_last, max_struct=0, struct_size;
<a name="line100">100: </a>  RealNumberType *MyANonz;


<a name="line104">104: </a>  <font color="#B22222">/* loop: to find maximum number of subscripts over columns</font>
<a name="line105">105: </a><font color="#B22222">     assigned to this processor */</font>
<a name="line106">106: </a>  <font color="#4169E1">for</font> (i=0; i &lt;NumLocalStructs; i++) {
<a name="line107">107: </a>    <font color="#B22222">/* for each struct i (local) assigned to this processor */</font>
<a name="line108">108: </a>    <font color="#4169E1">if</font> (LocalStructLocalNum){
<a name="line109">109: </a>      iold = LocalStructLocalNum[i];
<a name="line110">110: </a>    } <font color="#4169E1">else</font> {
<a name="line111">111: </a>      iold = LocalStructOldNum[i];
<a name="line112">112: </a>    }
<a name="line113">113: </a>
<a name="line114">114: </a>    struct_size = AIndex[iold+1] - AIndex[iold];
<a name="line115">115: </a>    <font color="#4169E1">if</font> ( max_struct &lt;= struct_size) max_struct = struct_size;
<a name="line116">116: </a>  }

<a name="line118">118: </a>  <font color="#B22222">/* allocate tmp arrays large enough to hold densest struct */</font>
<a name="line119">119: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((2*max_struct+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;NewColNum);
<a name="line120">120: </a>  idx = NewColNum + max_struct;
<a name="line121">121: </a>
<a name="line122">122: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(NumLocalNonz*<font color="#4169E1">sizeof</font>(RealNumberType),&amp;MyANonz);
<a name="line123">123: </a>  *adr_MyANonz = MyANonz;

<a name="line125">125: </a>  <font color="#B22222">/* loop to set up nonzeroes in MyANonz */</font>
<a name="line126">126: </a>  MyANonz_last = 0 ; <font color="#B22222">/* points to first empty space in MyANonz */</font>
<a name="line127">127: </a>  <font color="#4169E1">for</font> (i=0; i &lt;NumLocalStructs; i++) {

<a name="line129">129: </a>    <font color="#B22222">/* for each struct i (local) assigned to this processor */</font>
<a name="line130">130: </a>    <font color="#4169E1">if</font> (LocalStructLocalNum){
<a name="line131">131: </a>      iold = LocalStructLocalNum[i];
<a name="line132">132: </a>    } <font color="#4169E1">else</font> {
<a name="line133">133: </a>      iold = LocalStructOldNum[i];
<a name="line134">134: </a>    }

<a name="line136">136: </a>    struct_size = AIndex[iold+1] - AIndex[iold];
<a name="line137">137: </a>    <font color="#4169E1">for</font> (k=0, j=AIndex[iold]; j&lt;AIndex[iold+1]; j++){
<a name="line138">138: </a>      NewColNum[k] = GlobalStructNewColNum[AStruct[j]];
<a name="line139">139: </a>      k++;
<a name="line140">140: </a>    }
<a name="line141">141: </a>    isort2(struct_size, NewColNum, idx);
<a name="line142">142: </a>
<a name="line143">143: </a>    kk = AIndex[iold]*bs2; <font color="#B22222">/* points to 1st element of iold block col in ANonz */</font>
<a name="line144">144: </a>    inew = GlobalStructNewColNum[LocalStructOldNum[i]];

<a name="line146">146: </a>    <font color="#4169E1">for</font> (jj = 0; jj &lt; bs; jj++) {
<a name="line147">147: </a>      <font color="#4169E1">for</font> (j=0; j&lt;struct_size; j++){
<a name="line148">148: </a>        <font color="#4169E1">for</font> ( k = 0; k&lt;bs; k++){
<a name="line149">149: </a>          <font color="#4169E1">if</font> (NewColNum[idx[j]] + k &gt;= inew)
<a name="line150">150: </a>            MyANonz[MyANonz_last++] = ANonz[kk + idx[j]*bs2 + k*bs + jj];
<a name="line151">151: </a>        }
<a name="line152">152: </a>      }
<a name="line153">153: </a>      inew++;
<a name="line154">154: </a>    }
<a name="line155">155: </a>  } <font color="#B22222">/* end outer loop for i */</font>

<a name="line157">157: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(NewColNum);
<a name="line158">158: </a>  <font color="#4169E1">if</font> (MyANonz_last != NumLocalNonz) <A href="../../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_PLIB,<font color="#666666">"MyANonz_last %d != NumLocalNonz %d\n"</font>,MyANonz_last, NumLocalNonz);
<a name="line159">159: </a>  <font color="#4169E1">return</font>(0);
<a name="line160">160: </a>}

<a name="line165">165: </a><strong><font color="#4169E1"><a name="MatConvert_DSCPACK_BAIJ"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_DSCPACK_BAIJ(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,const <A href="../../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A> type,<A href="../../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A> reuse,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *newmat)</font></strong>
<a name="line166">166: </a>{
<a name="line168">168: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            B=*newmat;
<a name="line169">169: </a>  Mat_DSC        *lu=(Mat_DSC*)A-&gt;spptr;
<a name="line170">170: </a>  void           (*f)(void);

<a name="line173">173: </a>  <font color="#4169E1">if</font> (reuse == MAT_INITIAL_MATRIX) {
<a name="line174">174: </a>    <A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>(A,MAT_COPY_VALUES,&amp;B);
<a name="line175">175: </a>  }
<a name="line176">176: </a>  <font color="#B22222">/* Reset the original function pointers */</font>
<a name="line177">177: </a>  B-&gt;ops-&gt;duplicate              = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>;
<a name="line178">178: </a>  B-&gt;ops-&gt;view                   = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>;
<a name="line179">179: </a>  B-&gt;ops-&gt;assemblyend            = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>;
<a name="line180">180: </a>  B-&gt;ops-&gt;choleskyfactorsymbolic = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactorSymbolic.html#MatCholeskyFactorSymbolic">MatCholeskyFactorSymbolic</A>;
<a name="line181">181: </a>  B-&gt;ops-&gt;destroy                = lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>;
<a name="line182">182: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatMPIBAIJSetPreallocation_C"</font>,&amp;f);
<a name="line183">183: </a>  <font color="#4169E1">if</font> (f) {
<a name="line184">184: </a>    PetscObjectComposeFunction((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatMPIBAIJSetPreallocation_C"</font>,<font color="#666666">""</font>,(PetscVoidFunction)lu-&gt;MatPreallocate);
<a name="line185">185: </a>  }

<a name="line187">187: </a>  PetscObjectComposeFunction((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_seqbaij_dscpack_C"</font>,<font color="#666666">""</font>,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line188">188: </a>  PetscObjectComposeFunction((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_dscpack_seqbaij_C"</font>,<font color="#666666">""</font>,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line189">189: </a>  PetscObjectComposeFunction((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_mpibaij_dscpack_C"</font>,<font color="#666666">""</font>,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line190">190: </a>  PetscObjectComposeFunction((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_dscpack_mpibaij_C"</font>,<font color="#666666">""</font>,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line192">192: </a>  PetscObjectChangeTypeName((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,type);
<a name="line193">193: </a>  *newmat = B;

<a name="line195">195: </a>  <font color="#4169E1">return</font>(0);
<a name="line196">196: </a>}

<a name="line201">201: </a><strong><font color="#4169E1"><a name="MatDestroy_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDestroy_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A)</font></strong>
<a name="line202">202: </a>{
<a name="line203">203: </a>  Mat_DSC        *lu=(Mat_DSC*)A-&gt;spptr;
<a name="line205">205: </a>
<a name="line207">207: </a>  <font color="#4169E1">if</font> (lu-&gt;CleanUpDSCPACK) {
<a name="line208">208: </a>    <font color="#4169E1">if</font> (lu-&gt;dsc_id != -1) {
<a name="line209">209: </a>      <font color="#4169E1">if</font>(lu-&gt;stat) DSC_DoStats(lu-&gt;My_DSC_Solver);
<a name="line210">210: </a>      DSC_FreeAll(lu-&gt;My_DSC_Solver);
<a name="line211">211: </a>      DSC_Close0(lu-&gt;My_DSC_Solver);
<a name="line212">212: </a>
<a name="line213">213: </a>      <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(lu-&gt;local_cols_old_num);
<a name="line214">214: </a>    }
<a name="line215">215: </a>    DSC_End(lu-&gt;My_DSC_Solver);
<a name="line216">216: </a>
<a name="line217">217: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_free.html#MPI_Comm_free">MPI_Comm_free</A>(&amp;(lu-&gt;comm_dsc));
<a name="line218">218: </a>    <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(lu-&gt;my_cols);
<a name="line219">219: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(lu-&gt;replication);
<a name="line220">220: </a>    <A href="../../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(lu-&gt;vec_dsc);
<a name="line221">221: </a>    <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(lu-&gt;iden_dsc);
<a name="line222">222: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterDestroy.html#VecScatterDestroy">VecScatterDestroy</A>(lu-&gt;scat);
<a name="line223">223: </a>    <font color="#4169E1">if</font> (lu-&gt;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> &gt;1 &amp;&amp; lu-&gt;iden) {<A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(lu-&gt;iden);}
<a name="line224">224: </a>  }
<a name="line225">225: </a>  <font color="#4169E1">if</font> (lu-&gt;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> == 1) {
<a name="line226">226: </a>    MatConvert_DSCPACK_BAIJ(A,<A href="../../../../../../docs/manualpages/Mat/MATSEQBAIJ.html#MATSEQBAIJ">MATSEQBAIJ</A>,MAT_REUSE_MATRIX,&amp;A);
<a name="line227">227: </a>  } <font color="#4169E1">else</font> {
<a name="line228">228: </a>    MatConvert_DSCPACK_BAIJ(A,<A href="../../../../../../docs/manualpages/Mat/MATMPIBAIJ.html#MATMPIBAIJ">MATMPIBAIJ</A>,MAT_REUSE_MATRIX,&amp;A);
<a name="line229">229: </a>  }
<a name="line230">230: </a>  (*A-&gt;ops-&gt;destroy)(A);
<a name="line231">231: </a>  <font color="#4169E1">return</font>(0);
<a name="line232">232: </a>}

<a name="line236">236: </a><strong><font color="#4169E1"><a name="MatSolve_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSolve_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> b,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x)</font></strong> {
<a name="line237">237: </a>  Mat_DSC        *lu= (Mat_DSC*)A-&gt;spptr;
<a name="line239">239: </a>  RealNumberType *solution_vec,*rhs_vec;

<a name="line242">242: </a>  <font color="#B22222">/* scatter b into seq vec_dsc */</font>
<a name="line243">243: </a>  <font color="#4169E1">if</font> ( !lu-&gt;scat ) {
<a name="line244">244: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterCreate.html#VecScatterCreate">VecScatterCreate</A>(b,lu-&gt;my_cols,lu-&gt;vec_dsc,lu-&gt;iden_dsc,&amp;lu-&gt;scat);
<a name="line245">245: </a>  }
<a name="line246">246: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(b,lu-&gt;vec_dsc,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,lu-&gt;scat);
<a name="line247">247: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>(b,lu-&gt;vec_dsc,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,lu-&gt;scat);

<a name="line249">249: </a>  <font color="#4169E1">if</font> (lu-&gt;dsc_id != -1){
<a name="line250">250: </a>    <A href="../../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(lu-&gt;vec_dsc,&amp;rhs_vec);
<a name="line251">251: </a>    DSC_InputRhsLocalVec(lu-&gt;My_DSC_Solver, rhs_vec, lu-&gt;num_local_cols);
<a name="line252">252: </a>    <A href="../../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(lu-&gt;vec_dsc,&amp;rhs_vec);
<a name="line253">253: </a>
<a name="line254">254: </a>    DSC_Solve(lu-&gt;My_DSC_Solver);
<a name="line255">255: </a>    <font color="#4169E1">if</font> (ierr !=  DSC_NO_ERROR) {
<a name="line256">256: </a>      DSC_ErrorDisplay(lu-&gt;My_DSC_Solver);
<a name="line257">257: </a>      <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_LIB,<font color="#666666">"Error in calling DSC_Solve"</font>);
<a name="line258">258: </a>    }

<a name="line260">260: </a>    <font color="#B22222">/* get the permuted local solution */</font>
<a name="line261">261: </a>    <A href="../../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(lu-&gt;vec_dsc,&amp;solution_vec);
<a name="line262">262: </a>    DSC_GetLocalSolution(lu-&gt;My_DSC_Solver,solution_vec, lu-&gt;num_local_cols);
<a name="line263">263: </a>    <A href="../../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(lu-&gt;vec_dsc,&amp;solution_vec);

<a name="line265">265: </a>  } <font color="#B22222">/* end of if (lu-&gt;dsc_id != -1) */</font>

<a name="line267">267: </a>  <font color="#B22222">/* put permuted local solution solution_vec into x in the original order */</font>
<a name="line268">268: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(lu-&gt;vec_dsc,x,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,lu-&gt;scat);
<a name="line269">269: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>(lu-&gt;vec_dsc,x,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,lu-&gt;scat);

<a name="line271">271: </a>  <font color="#4169E1">return</font>(0);
<a name="line272">272: </a>}

<a name="line276">276: </a><strong><font color="#4169E1"><a name="MatCholeskyFactorNumeric_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatCholeskyFactorNumeric_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *F)</font></strong> {
<a name="line277">277: </a>  Mat_SeqBAIJ    *a_seq;
<a name="line278">278: </a>  Mat_DSC        *lu=(Mat_DSC*)(*F)-&gt;spptr;
<a name="line279">279: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            *tseq,A_seq=<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>;
<a name="line280">280: </a>  RealNumberType *my_a_nonz;
<a name="line282">282: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line283">283: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       M=A-&gt;rmap.N,Mbs=M/lu-&gt;bs,max_mem_estimate,max_single_malloc_blk,
<a name="line284">284: </a>                 number_of_procs,i,j,next,iold,*idx,*iidx=0,*itmp;
<a name="line285">285: </a>  <A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A>             my_cols_sorted;
<a name="line286">286: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            F_diag;
<a name="line287">287: </a>
<a name="line289">289: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(A-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line290">290: </a>  <font color="#4169E1">if</font> ( lu-&gt;flg == DIFFERENT_NONZERO_PATTERN){ <font color="#B22222">/* first numeric factorization */</font>
<a name="line291">291: </a>    <font color="#B22222">/* convert A to A_seq */</font>
<a name="line292">292: </a>    <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> &gt; 1) {
<a name="line293">293: </a>      <font color="#4169E1">if</font> (!lu-&gt;iden){
<a name="line294">294: </a>        <A href="../../../../../../docs/manualpages/IS/ISCreateStride.html#ISCreateStride">ISCreateStride</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,M,0,1,&amp;lu-&gt;iden);
<a name="line295">295: </a>      }
<a name="line296">296: </a>      <A href="../../../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(A,1,&amp;lu-&gt;iden,&amp;lu-&gt;iden,MAT_INITIAL_MATRIX,&amp;tseq);
<a name="line297">297: </a>      A_seq = tseq[0];
<a name="line298">298: </a>      a_seq = (Mat_SeqBAIJ*)A_seq-&gt;data;
<a name="line299">299: </a>    } <font color="#4169E1">else</font> {
<a name="line300">300: </a>      a_seq = (Mat_SeqBAIJ*)A-&gt;data;
<a name="line301">301: </a>    }
<a name="line302">302: </a>
<a name="line303">303: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(Mbs*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;lu-&gt;replication);
<a name="line304">304: </a>    <font color="#4169E1">for</font> (i=0; i&lt;Mbs; i++) lu-&gt;replication[i] = lu-&gt;bs;

<a name="line306">306: </a>    number_of_procs = DSC_Analyze(Mbs, a_seq-&gt;i, a_seq-&gt;j, lu-&gt;replication);
<a name="line307">307: </a>
<a name="line308">308: </a>    i = <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line309">309: </a>    <font color="#4169E1">if</font> ( number_of_procs &lt; i ) i = number_of_procs;
<a name="line310">310: </a>    number_of_procs = 1;
<a name="line311">311: </a>    <font color="#4169E1">while</font> ( i &gt; 1 ){
<a name="line312">312: </a>      number_of_procs  *= 2; i /= 2;
<a name="line313">313: </a>    }

<a name="line315">315: </a>    <font color="#B22222">/* DSC_Solver starts */</font>
<a name="line316">316: </a>    DSC_Open0( lu-&gt;My_DSC_Solver, number_of_procs, &amp;lu-&gt;dsc_id, lu-&gt;comm_dsc );

<a name="line318">318: </a>    <font color="#4169E1">if</font> (lu-&gt;dsc_id != -1) {
<a name="line319">319: </a>      DSC_Order(lu-&gt;My_DSC_Solver,lu-&gt;order_code,Mbs,a_seq-&gt;i,a_seq-&gt;j,lu-&gt;replication,
<a name="line320">320: </a>                   &amp;M,&amp;lu-&gt;num_local_strucs,
<a name="line321">321: </a>                   &amp;lu-&gt;num_local_cols, &amp;lu-&gt;num_local_nonz,  &amp;lu-&gt;global_struc_new_col_num,
<a name="line322">322: </a>                   &amp;lu-&gt;global_struc_new_num, &amp;lu-&gt;global_struc_owner,
<a name="line323">323: </a>                   &amp;lu-&gt;local_struc_old_num);
<a name="line324">324: </a>      <font color="#4169E1">if</font> (ierr !=  DSC_NO_ERROR) {
<a name="line325">325: </a>        DSC_ErrorDisplay(lu-&gt;My_DSC_Solver);
<a name="line326">326: </a>        <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_LIB,<font color="#666666">"Error when use DSC_Order()"</font>);
<a name="line327">327: </a>      }

<a name="line329">329: </a>      DSC_SFactor(lu-&gt;My_DSC_Solver,&amp;max_mem_estimate,&amp;max_single_malloc_blk,
<a name="line330">330: </a>                     lu-&gt;max_mem_allowed, lu-&gt;LBLASLevel, lu-&gt;DBLASLevel);
<a name="line331">331: </a>      <font color="#4169E1">if</font> (ierr !=  DSC_NO_ERROR) {
<a name="line332">332: </a>        DSC_ErrorDisplay(lu-&gt;My_DSC_Solver);
<a name="line333">333: </a>        <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_LIB,<font color="#666666">"Error when use DSC_Order"</font>);
<a name="line334">334: </a>      }

<a name="line336">336: </a>      BAIJtoMyANonz(a_seq-&gt;i, a_seq-&gt;j, lu-&gt;bs, a_seq-&gt;a,
<a name="line337">337: </a>                       lu-&gt;num_local_strucs, lu-&gt;num_local_nonz,
<a name="line338">338: </a>                       lu-&gt;global_struc_new_col_num,
<a name="line339">339: </a>                       lu-&gt;local_struc_old_num,
<a name="line340">340: </a>                       <A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,
<a name="line341">341: </a>                       &amp;my_a_nonz);
<a name="line342">342: </a>      <font color="#4169E1">if</font> (ierr &lt;0) {
<a name="line343">343: </a>          DSC_ErrorDisplay(lu-&gt;My_DSC_Solver);
<a name="line344">344: </a>          <A href="../../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_LIB,<font color="#666666">"Error setting local nonzeroes at processor %d \n"</font>, lu-&gt;dsc_id);
<a name="line345">345: </a>      }

<a name="line347">347: </a>      <font color="#B22222">/* get local_cols_old_num and <A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A> my_cols to be used later */</font>
<a name="line348">348: </a>      <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(lu-&gt;num_local_cols*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;lu-&gt;local_cols_old_num);
<a name="line349">349: </a>      <font color="#4169E1">for</font> (next = 0, i=0; i&lt;lu-&gt;num_local_strucs; i++){
<a name="line350">350: </a>        iold = lu-&gt;bs*lu-&gt;local_struc_old_num[i];
<a name="line351">351: </a>        <font color="#4169E1">for</font> (j=0; j&lt;lu-&gt;bs; j++)
<a name="line352">352: </a>          lu-&gt;local_cols_old_num[next++] = iold++;
<a name="line353">353: </a>      }
<a name="line354">354: </a>      <A href="../../../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,lu-&gt;num_local_cols,lu-&gt;local_cols_old_num,&amp;lu-&gt;my_cols);
<a name="line355">355: </a>
<a name="line356">356: </a>    } <font color="#4169E1">else</font> {    <font color="#B22222">/* lu-&gt;dsc_id == -1 */</font>
<a name="line357">357: </a>      lu-&gt;num_local_cols = 0;
<a name="line358">358: </a>      lu-&gt;local_cols_old_num = 0;
<a name="line359">359: </a>      <A href="../../../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,lu-&gt;num_local_cols,lu-&gt;local_cols_old_num,&amp;lu-&gt;my_cols);
<a name="line360">360: </a>    }
<a name="line361">361: </a>    <font color="#B22222">/* generate vec_dsc and iden_dsc to be used later */</font>
<a name="line362">362: </a>    <A href="../../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,lu-&gt;num_local_cols,&amp;lu-&gt;vec_dsc);
<a name="line363">363: </a>    <A href="../../../../../../docs/manualpages/IS/ISCreateStride.html#ISCreateStride">ISCreateStride</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,lu-&gt;num_local_cols,0,1,&amp;lu-&gt;iden_dsc);
<a name="line364">364: </a>    lu-&gt;scat = <A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>;

<a name="line366">366: </a>    <font color="#4169E1">if</font> ( <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>&gt;1 ) {
<a name="line367">367: </a>      <A href="../../../../../../docs/manualpages/Mat/MatDestroyMatrices.html#MatDestroyMatrices">MatDestroyMatrices</A>(1,&amp;tseq);
<a name="line368">368: </a>    }
<a name="line369">369: </a>  } <font color="#4169E1">else</font> { <font color="#B22222">/* use previously computed symbolic factor */</font>
<a name="line370">370: </a>    <font color="#B22222">/* convert A to my A_seq */</font>
<a name="line371">371: </a>    <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> &gt; 1) {
<a name="line372">372: </a>      <font color="#4169E1">if</font> (lu-&gt;dsc_id == -1) {
<a name="line373">373: </a>        itmp = 0;
<a name="line374">374: </a>      } <font color="#4169E1">else</font> {
<a name="line375">375: </a>        <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(2*lu-&gt;num_local_strucs*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;idx);
<a name="line376">376: </a>        iidx = idx + lu-&gt;num_local_strucs;
<a name="line377">377: </a>        <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(lu-&gt;num_local_cols*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;itmp);
<a name="line378">378: </a>
<a name="line379">379: </a>        isort2(lu-&gt;num_local_strucs, lu-&gt;local_struc_old_num, idx);
<a name="line380">380: </a>        <font color="#4169E1">for</font> (next=0, i=0; i&lt; lu-&gt;num_local_strucs; i++) {
<a name="line381">381: </a>          iold = lu-&gt;bs*lu-&gt;local_struc_old_num[idx[i]];
<a name="line382">382: </a>          <font color="#4169E1">for</font> (j=0; j&lt;lu-&gt;bs; j++){
<a name="line383">383: </a>            itmp[next++] = iold++; <font color="#B22222">/* sorted local_cols_old_num */</font>
<a name="line384">384: </a>          }
<a name="line385">385: </a>        }
<a name="line386">386: </a>        <font color="#4169E1">for</font> (i=0; i&lt; lu-&gt;num_local_strucs; i++) {
<a name="line387">387: </a>          iidx[idx[i]] = i;       <font color="#B22222">/* inverse of idx */</font>
<a name="line388">388: </a>        }
<a name="line389">389: </a>      } <font color="#B22222">/* end of (lu-&gt;dsc_id == -1) */</font>
<a name="line390">390: </a>      <A href="../../../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,lu-&gt;num_local_cols,itmp,&amp;my_cols_sorted);
<a name="line391">391: </a>      <A href="../../../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(A,1,&amp;my_cols_sorted,&amp;lu-&gt;iden,MAT_INITIAL_MATRIX,&amp;tseq);
<a name="line392">392: </a>      <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(my_cols_sorted);
<a name="line393">393: </a>      A_seq = tseq[0];
<a name="line394">394: </a>
<a name="line395">395: </a>      <font color="#4169E1">if</font> (lu-&gt;dsc_id != -1) {
<a name="line396">396: </a>        DSC_ReFactorInitialize(lu-&gt;My_DSC_Solver);

<a name="line398">398: </a>        a_seq = (Mat_SeqBAIJ*)A_seq-&gt;data;
<a name="line399">399: </a>        BAIJtoMyANonz(a_seq-&gt;i, a_seq-&gt;j, lu-&gt;bs, a_seq-&gt;a,
<a name="line400">400: </a>                       lu-&gt;num_local_strucs, lu-&gt;num_local_nonz,
<a name="line401">401: </a>                       lu-&gt;global_struc_new_col_num,
<a name="line402">402: </a>                       lu-&gt;local_struc_old_num,
<a name="line403">403: </a>                       iidx,
<a name="line404">404: </a>                       &amp;my_a_nonz);
<a name="line405">405: </a>        <font color="#4169E1">if</font> (ierr &lt;0) {
<a name="line406">406: </a>          DSC_ErrorDisplay(lu-&gt;My_DSC_Solver);
<a name="line407">407: </a>          <A href="../../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_LIB,<font color="#666666">"Error setting local nonzeroes at processor %d \n"</font>, lu-&gt;dsc_id);
<a name="line408">408: </a>        }
<a name="line409">409: </a>        <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(idx);
<a name="line410">410: </a>        <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(itmp);
<a name="line411">411: </a>      } <font color="#B22222">/* end of if(lu-&gt;dsc_id != -1)  */</font>
<a name="line412">412: </a>    } <font color="#4169E1">else</font> { <font color="#B22222">/* <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> == 1 */</font>
<a name="line413">413: </a>      a_seq = (Mat_SeqBAIJ*)A-&gt;data;
<a name="line414">414: </a>
<a name="line415">415: </a>      BAIJtoMyANonz(a_seq-&gt;i, a_seq-&gt;j, lu-&gt;bs, a_seq-&gt;a,
<a name="line416">416: </a>                       lu-&gt;num_local_strucs, lu-&gt;num_local_nonz,
<a name="line417">417: </a>                       lu-&gt;global_struc_new_col_num,
<a name="line418">418: </a>                       lu-&gt;local_struc_old_num,
<a name="line419">419: </a>                       <A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,
<a name="line420">420: </a>                       &amp;my_a_nonz);
<a name="line421">421: </a>      <font color="#4169E1">if</font> (ierr &lt;0) {
<a name="line422">422: </a>        DSC_ErrorDisplay(lu-&gt;My_DSC_Solver);
<a name="line423">423: </a>        <A href="../../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_LIB,<font color="#666666">"Error setting local nonzeroes at processor %d \n"</font>, lu-&gt;dsc_id);
<a name="line424">424: </a>      }
<a name="line425">425: </a>    }
<a name="line426">426: </a>    <font color="#4169E1">if</font> ( <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>&gt;1 ) {<A href="../../../../../../docs/manualpages/Mat/MatDestroyMatrices.html#MatDestroyMatrices">MatDestroyMatrices</A>(1,&amp;tseq); }
<a name="line427">427: </a>  }
<a name="line428">428: </a>
<a name="line429">429: </a>  <font color="#4169E1">if</font> (lu-&gt;dsc_id != -1) {
<a name="line430">430: </a>    DSC_NFactor(lu-&gt;My_DSC_Solver, lu-&gt;scheme_code, my_a_nonz, lu-&gt;factor_type, lu-&gt;LBLASLevel, lu-&gt;DBLASLevel);
<a name="line431">431: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(my_a_nonz);
<a name="line432">432: </a>  }
<a name="line433">433: </a>
<a name="line434">434: </a>  <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> &gt; 1) {
<a name="line435">435: </a>    F_diag = ((Mat_MPIBAIJ *)(*F)-&gt;data)-&gt;A;
<a name="line436">436: </a>    F_diag-&gt;assembled = <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line437">437: </a>  }
<a name="line438">438: </a>  (*F)-&gt;assembled   = <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line439">439: </a>  lu-&gt;flg           = SAME_NONZERO_PATTERN;

<a name="line441">441: </a>  <font color="#4169E1">return</font>(0);
<a name="line442">442: </a>}

<a name="line444">444: </a><font color="#B22222">/* Note the Petsc permutation r is ignored */</font>
<a name="line447">447: </a><strong><font color="#4169E1"><a name="MatCholeskyFactorSymbolic_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatCholeskyFactorSymbolic_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A> r,<A href="../../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *F)</font></strong> {
<a name="line448">448: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>        B;
<a name="line449">449: </a>  Mat_DSC    *lu;
<a name="line451">451: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> bs,indx;
<a name="line452">452: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flg;
<a name="line453">453: </a>  const char *ftype[]={<font color="#666666">"LDLT"</font>,<font color="#666666">"LLT"</font>},*ltype[]={<font color="#666666">"LBLAS1"</font>,<font color="#666666">"LBLAS2"</font>,<font color="#666666">"LBLAS3"</font>},*dtype[]={<font color="#666666">"DBLAS1"</font>,<font color="#666666">"DBLAS2"</font>};


<a name="line457">457: </a>  <font color="#B22222">/* Create the factorization matrix F */</font>
<a name="line458">458: </a>  <A href="../../../../../../docs/manualpages/Mat/MatGetBlockSize.html#MatGetBlockSize">MatGetBlockSize</A>(A,&amp;bs);
<a name="line459">459: </a>  <A href="../../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(A-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;B);
<a name="line460">460: </a>  <A href="../../../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(B,A-&gt;rmap.n,A-&gt;cmap.n,A-&gt;rmap.N,A-&gt;cmap.N);
<a name="line461">461: </a>  <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(B,A-&gt;type_name);
<a name="line462">462: </a>  <A href="../../../../../../docs/manualpages/Mat/MatSeqBAIJSetPreallocation.html#MatSeqBAIJSetPreallocation">MatSeqBAIJSetPreallocation</A>(B,bs,0,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line463">463: </a>  <A href="../../../../../../docs/manualpages/Mat/MatMPIBAIJSetPreallocation.html#MatMPIBAIJSetPreallocation">MatMPIBAIJSetPreallocation</A>(B,bs,0,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,0,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line464">464: </a>
<a name="line465">465: </a>  lu = (Mat_DSC*)B-&gt;spptr;
<a name="line466">466: </a>  B-&gt;rmap.bs = bs;

<a name="line468">468: </a>  B-&gt;ops-&gt;choleskyfactornumeric  = MatCholeskyFactorNumeric_DSCPACK;
<a name="line469">469: </a>  B-&gt;ops-&gt;solve                  = MatSolve_DSCPACK;
<a name="line470">470: </a>  B-&gt;factor                      = FACTOR_CHOLESKY;

<a name="line472">472: </a>  <font color="#B22222">/* Set the default input options */</font>
<a name="line473">473: </a>  lu-&gt;order_code  = 2;
<a name="line474">474: </a>  lu-&gt;scheme_code = 1;
<a name="line475">475: </a>  lu-&gt;factor_type = 2;
<a name="line476">476: </a>  lu-&gt;stat        = 0; <font color="#B22222">/* do not display stats */</font>
<a name="line477">477: </a>  lu-&gt;LBLASLevel  = DSC_LBLAS3;
<a name="line478">478: </a>  lu-&gt;DBLASLevel  = DSC_DBLAS2;
<a name="line479">479: </a>  lu-&gt;max_mem_allowed = 256;
<a name="line480">480: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_dup.html#MPI_Comm_dup">MPI_Comm_dup</A>(A-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;(lu-&gt;comm_dsc));
<a name="line481">481: </a>  <font color="#B22222">/* Get the runtime input options */</font>
<a name="line482">482: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsBegin.html#PetscOptionsBegin">PetscOptionsBegin</A>(A-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,A-&gt;prefix,<font color="#666666">"DSCPACK Options"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>"</font>);

<a name="line484">484: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsInt.html#PetscOptionsInt">PetscOptionsInt</A>(<font color="#666666">"-mat_dscpack_order"</font>,<font color="#666666">"order_code: \n\</font>
<a name="line485">485: </a><font color="#666666">         1 = ND, 2 = Hybrid with Minimum Degree, 3 = Hybrid with Minimum Deficiency"</font>, \
<a name="line486">486: </a>         <font color="#666666">"None"</font>,
<a name="line487">487: </a>         lu-&gt;order_code,&amp;lu-&gt;order_code,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line489">489: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsInt.html#PetscOptionsInt">PetscOptionsInt</A>(<font color="#666666">"-mat_dscpack_scheme"</font>,<font color="#666666">"scheme_code: \n\</font>
<a name="line490">490: </a><font color="#666666">         1 = standard factorization,  2 = factorization + selective inversion"</font>, \
<a name="line491">491: </a>         <font color="#666666">"None"</font>,
<a name="line492">492: </a>         lu-&gt;scheme_code,&amp;lu-&gt;scheme_code,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line493">493: </a>
<a name="line494">494: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsEList.html#PetscOptionsEList">PetscOptionsEList</A>(<font color="#666666">"-mat_dscpack_factor"</font>,<font color="#666666">"factor_type"</font>,<font color="#666666">"None"</font>,ftype,2,ftype[0],&amp;indx,&amp;flg);
<a name="line495">495: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line496">496: </a>    <font color="#4169E1">switch</font> (indx) {
<a name="line497">497: </a>    <font color="#4169E1">case</font> 0:
<a name="line498">498: </a>      lu-&gt;factor_type = DSC_LDLT;
<a name="line499">499: </a>      <font color="#4169E1">break</font>;
<a name="line500">500: </a>    <font color="#4169E1">case</font> 1:
<a name="line501">501: </a>      lu-&gt;factor_type = DSC_LLT;
<a name="line502">502: </a>      <font color="#4169E1">break</font>;
<a name="line503">503: </a>    }
<a name="line504">504: </a>  }
<a name="line505">505: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsInt.html#PetscOptionsInt">PetscOptionsInt</A>(<font color="#666666">"-mat_dscpack_MaxMemAllowed"</font>,<font color="#666666">"in Mbytes"</font>,<font color="#666666">"None"</font>,
<a name="line506">506: </a>         lu-&gt;max_mem_allowed,&amp;lu-&gt;max_mem_allowed,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line508">508: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsInt.html#PetscOptionsInt">PetscOptionsInt</A>(<font color="#666666">"-mat_dscpack_stats"</font>,<font color="#666666">"display stats: 0 = no display,  1 = display"</font>,
<a name="line509">509: </a>         <font color="#666666">"None"</font>, lu-&gt;stat,&amp;lu-&gt;stat,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line510">510: </a>
<a name="line511">511: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsEList.html#PetscOptionsEList">PetscOptionsEList</A>(<font color="#666666">"-mat_dscpack_LBLAS"</font>,<font color="#666666">"BLAS level used in the local phase"</font>,<font color="#666666">"None"</font>,ltype,3,ltype[2],&amp;indx,&amp;flg);
<a name="line512">512: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line513">513: </a>    <font color="#4169E1">switch</font> (indx) {
<a name="line514">514: </a>    <font color="#4169E1">case</font> 0:
<a name="line515">515: </a>      lu-&gt;LBLASLevel = DSC_LBLAS1;
<a name="line516">516: </a>      <font color="#4169E1">break</font>;
<a name="line517">517: </a>    <font color="#4169E1">case</font> 1:
<a name="line518">518: </a>      lu-&gt;LBLASLevel = DSC_LBLAS2;
<a name="line519">519: </a>      <font color="#4169E1">break</font>;
<a name="line520">520: </a>    <font color="#4169E1">case</font> 2:
<a name="line521">521: </a>      lu-&gt;LBLASLevel = DSC_LBLAS3;
<a name="line522">522: </a>      <font color="#4169E1">break</font>;
<a name="line523">523: </a>    }
<a name="line524">524: </a>  }

<a name="line526">526: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsEList.html#PetscOptionsEList">PetscOptionsEList</A>(<font color="#666666">"-mat_dscpack_DBLAS"</font>,<font color="#666666">"BLAS level used in the distributed phase"</font>,<font color="#666666">"None"</font>,dtype,2,dtype[1],&amp;indx,&amp;flg);
<a name="line527">527: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line528">528: </a>    <font color="#4169E1">switch</font> (indx) {
<a name="line529">529: </a>    <font color="#4169E1">case</font> 0:
<a name="line530">530: </a>      lu-&gt;DBLASLevel = DSC_DBLAS1;
<a name="line531">531: </a>      <font color="#4169E1">break</font>;
<a name="line532">532: </a>    <font color="#4169E1">case</font> 1:
<a name="line533">533: </a>      lu-&gt;DBLASLevel = DSC_DBLAS2;
<a name="line534">534: </a>      <font color="#4169E1">break</font>;
<a name="line535">535: </a>    }
<a name="line536">536: </a>  }

<a name="line538">538: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsEnd.html#PetscOptionsEnd">PetscOptionsEnd</A>();
<a name="line539">539: </a>
<a name="line540">540: </a>  lu-&gt;flg = DIFFERENT_NONZERO_PATTERN;

<a name="line542">542: </a>  lu-&gt;My_DSC_Solver = DSC_Begin();
<a name="line543">543: </a>  lu-&gt;CleanUpDSCPACK = <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line544">544: </a>  *F = B;
<a name="line545">545: </a>  <font color="#4169E1">return</font>(0);
<a name="line546">546: </a>}

<a name="line550">550: </a><strong><font color="#4169E1"><a name="MatAssemblyEnd_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatAssemblyEnd_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Mat/MatAssemblyType.html#MatAssemblyType">MatAssemblyType</A> mode)</font></strong> {
<a name="line552">552: </a>  Mat_DSC *lu=(Mat_DSC*)A-&gt;spptr;

<a name="line555">555: </a>  (*lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>)(A,mode);
<a name="line556">556: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactorSymbolic.html#MatCholeskyFactorSymbolic">MatCholeskyFactorSymbolic</A>  = A-&gt;ops-&gt;choleskyfactorsymbolic;
<a name="line557">557: </a>  A-&gt;ops-&gt;choleskyfactorsymbolic = MatCholeskyFactorSymbolic_DSCPACK;
<a name="line558">558: </a>  <font color="#4169E1">return</font>(0);
<a name="line559">559: </a>}

<a name="line563">563: </a><strong><font color="#4169E1"><a name="MatFactorInfo_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatFactorInfo_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line564">564: </a>{
<a name="line565">565: </a>  Mat_DSC *lu=(Mat_DSC*)A-&gt;spptr;
<a name="line567">567: </a>  const char    *s=0;
<a name="line568">568: </a>
<a name="line570">570: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"DSCPACK run parameters:\n"</font>);

<a name="line572">572: </a>  <font color="#4169E1">switch</font> (lu-&gt;order_code) {
<a name="line573">573: </a>  <font color="#4169E1">case</font> 1: s = <font color="#666666">"ND"</font>; <font color="#4169E1">break</font>;
<a name="line574">574: </a>  <font color="#4169E1">case</font> 2: s = <font color="#666666">"Hybrid with Minimum Degree"</font>; <font color="#4169E1">break</font>;
<a name="line575">575: </a>  <font color="#4169E1">case</font> 3: s = <font color="#666666">"Hybrid with Minimum Deficiency"</font>; <font color="#4169E1">break</font>;
<a name="line576">576: </a>  }
<a name="line577">577: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  order_code: %s \n"</font>,s);

<a name="line579">579: </a>  <font color="#4169E1">switch</font> (lu-&gt;scheme_code) {
<a name="line580">580: </a>  <font color="#4169E1">case</font> 1: s = <font color="#666666">"standard factorization"</font>; <font color="#4169E1">break</font>;
<a name="line581">581: </a>  <font color="#4169E1">case</font> 2: s = <font color="#666666">"factorization + selective inversion"</font>; <font color="#4169E1">break</font>;
<a name="line582">582: </a>  }
<a name="line583">583: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  scheme_code: %s \n"</font>,s);

<a name="line585">585: </a>  <font color="#4169E1">switch</font> (lu-&gt;stat) {
<a name="line586">586: </a>  <font color="#4169E1">case</font> 0: s = <font color="#666666">"NO"</font>; <font color="#4169E1">break</font>;
<a name="line587">587: </a>  <font color="#4169E1">case</font> 1: s = <font color="#666666">"YES"</font>; <font color="#4169E1">break</font>;
<a name="line588">588: </a>  }
<a name="line589">589: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  display stats: %s \n"</font>,s);
<a name="line590">590: </a>
<a name="line591">591: </a>  <font color="#4169E1">if</font> ( lu-&gt;factor_type == DSC_LLT) {
<a name="line592">592: </a>    s = <font color="#666666">"LLT"</font>;
<a name="line593">593: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> ( lu-&gt;factor_type == DSC_LDLT){
<a name="line594">594: </a>    s = <font color="#666666">"LDLT"</font>;
<a name="line595">595: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (lu-&gt;factor_type == 0) {
<a name="line596">596: </a>    s = <font color="#666666">"None"</font>;
<a name="line597">597: </a>  } <font color="#4169E1">else</font> {
<a name="line598">598: </a>    <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_PLIB,<font color="#666666">"Unknown factor type"</font>);
<a name="line599">599: </a>  }
<a name="line600">600: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  factor type: %s \n"</font>,s);

<a name="line602">602: </a>  <font color="#4169E1">if</font> ( lu-&gt;LBLASLevel == DSC_LBLAS1) {
<a name="line603">603: </a>    s = <font color="#666666">"BLAS1"</font>;
<a name="line604">604: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> ( lu-&gt;LBLASLevel == DSC_LBLAS2){
<a name="line605">605: </a>    s = <font color="#666666">"BLAS2"</font>;
<a name="line606">606: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> ( lu-&gt;LBLASLevel == DSC_LBLAS3){
<a name="line607">607: </a>    s = <font color="#666666">"BLAS3"</font>;
<a name="line608">608: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (lu-&gt;LBLASLevel == 0) {
<a name="line609">609: </a>    s = <font color="#666666">"None"</font>;
<a name="line610">610: </a>  } <font color="#4169E1">else</font> {
<a name="line611">611: </a>    <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_PLIB,<font color="#666666">"Unknown local phase BLAS level"</font>);
<a name="line612">612: </a>  }
<a name="line613">613: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  local phase BLAS level: %s \n"</font>,s);
<a name="line614">614: </a>
<a name="line615">615: </a>  <font color="#4169E1">if</font> ( lu-&gt;DBLASLevel == DSC_DBLAS1) {
<a name="line616">616: </a>    s = <font color="#666666">"BLAS1"</font>;
<a name="line617">617: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> ( lu-&gt;DBLASLevel == DSC_DBLAS2){
<a name="line618">618: </a>    s = <font color="#666666">"BLAS2"</font>;
<a name="line619">619: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (lu-&gt;DBLASLevel == 0) {
<a name="line620">620: </a>    s = <font color="#666666">"None"</font>;
<a name="line621">621: </a>  } <font color="#4169E1">else</font> {
<a name="line622">622: </a>    <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_PLIB,<font color="#666666">"Unknown distributed phase BLAS level"</font>);
<a name="line623">623: </a>  }
<a name="line624">624: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  distributed phase BLAS level: %s \n"</font>,s);
<a name="line625">625: </a>  <font color="#4169E1">return</font>(0);
<a name="line626">626: </a>}

<a name="line628">628: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatView_SeqBAIJ(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>)</font></strong>;
<a name="line629">629: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatView_MPIBAIJ(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>)</font></strong>;


<a name="line634">634: </a><strong><font color="#4169E1"><a name="MatView_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatView_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong> {
<a name="line635">635: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line636">636: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>       <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line637">637: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        iascii;
<a name="line638">638: </a>  <A href="../../../../../../docs/manualpages/Viewer/PetscViewerFormat.html#PetscViewerFormat">PetscViewerFormat</A> format;
<a name="line639">639: </a>  Mat_DSC           *lu=(Mat_DSC*)A-&gt;spptr;

<a name="line642">642: </a>  <font color="#B22222">/* Cannot view factored matrix */</font>
<a name="line643">643: </a>  <font color="#4169E1">if</font> (A-&gt;factor) {
<a name="line644">644: </a>    <font color="#4169E1">return</font>(0);
<a name="line645">645: </a>  }
<a name="line646">646: </a>  <font color="#B22222">/* This convertion ugliness is because <A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A> for BAIJ types calls <A href="../../../../../../docs/manualpages/Mat/MatConvert.html#MatConvert">MatConvert</A> to AIJ */</font>
<a name="line647">647: </a>  <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> = lu-&gt;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line648">648: </a>  <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>==1) {
<a name="line649">649: </a>    MatView_SeqBAIJ(A,viewer);
<a name="line650">650: </a>  } <font color="#4169E1">else</font> {
<a name="line651">651: </a>    MatView_MPIBAIJ(A,viewer);
<a name="line652">652: </a>  }

<a name="line654">654: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_ASCII,&amp;iascii);
<a name="line655">655: </a>  <font color="#4169E1">if</font> (iascii) {
<a name="line656">656: </a>    PetscViewerGetFormat(viewer,&amp;format);
<a name="line657">657: </a>    <font color="#4169E1">if</font> (format == PETSC_VIEWER_ASCII_INFO) {
<a name="line658">658: </a>      MatFactorInfo_DSCPACK(A,viewer);
<a name="line659">659: </a>    }
<a name="line660">660: </a>  }
<a name="line661">661: </a>  <font color="#4169E1">return</font>(0);
<a name="line662">662: </a>}

<a name="line667">667: </a><strong><font color="#4169E1"><a name="MatMPIBAIJSetPreallocation_MPIDSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatMPIBAIJSetPreallocation_MPIDSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>  B,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> bs,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> d_nz,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *d_nnz,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> o_nz,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *o_nnz)</font></strong>
<a name="line668">668: </a>{
<a name="line669">669: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>     A;
<a name="line670">670: </a>  Mat_DSC *lu = (Mat_DSC*)B-&gt;spptr;

<a name="line674">674: </a>  <font color="#B22222">/*</font>
<a name="line675">675: </a><font color="#B22222">    After performing the MPIBAIJ Preallocation, we need to convert the local diagonal block matrix</font>
<a name="line676">676: </a><font color="#B22222">    into DSCPACK type so that the block jacobi preconditioner (for example) can use DSCPACK.  I would</font>
<a name="line677">677: </a><font color="#B22222">    like this to be done in the <A href="../../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A> routine, but the creation of this inner matrix requires</font>
<a name="line678">678: </a><font color="#B22222">    block <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> info so that PETSc can determine the local <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> properly.  The block <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> info is set</font>
<a name="line679">679: </a><font color="#B22222">    in the preallocation routine.</font>
<a name="line680">680: </a><font color="#B22222">  */</font>
<a name="line681">681: </a>  (*lu-&gt;MatPreallocate)(B,bs,d_nz,d_nnz,o_nz,o_nnz);
<a name="line682">682: </a>  A    = ((Mat_MPIBAIJ *)B-&gt;data)-&gt;A;
<a name="line683">683: </a>  MatConvert_BAIJ_DSCPACK(A,<A href="../../../../../../docs/manualpages/Mat/MATDSCPACK.html#MATDSCPACK">MATDSCPACK</A>,MAT_REUSE_MATRIX,&amp;A);
<a name="line684">684: </a>  <font color="#4169E1">return</font>(0);
<a name="line685">685: </a>}

<a name="line691">691: </a><strong><font color="#4169E1"><a name="MatConvert_BAIJ_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatConvert_BAIJ_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,const <A href="../../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A> type,<A href="../../../../../../docs/manualpages/Mat/MatReuse.html#MatReuse">MatReuse</A> reuse,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *newmat)</font></strong>
<a name="line692">692: </a>{
<a name="line693">693: </a>  <font color="#B22222">/* This routine is only called to convert to <A href="../../../../../../docs/manualpages/Mat/MATDSCPACK.html#MATDSCPACK">MATDSCPACK</A> */</font>
<a name="line694">694: </a>  <font color="#B22222">/* from <A href="../../../../../../docs/manualpages/Mat/MATSEQBAIJ.html#MATSEQBAIJ">MATSEQBAIJ</A> if A has a single process communicator */</font>
<a name="line695">695: </a>  <font color="#B22222">/* or <A href="../../../../../../docs/manualpages/Mat/MATMPIBAIJ.html#MATMPIBAIJ">MATMPIBAIJ</A> otherwise, so we will ignore '<A href="../../../../../../docs/manualpages/Mat/MatType.html#MatType">MatType</A> type'. */</font>
<a name="line697">697: </a>  <A href="../../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A>       <A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>;
<a name="line698">698: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            B=*newmat;
<a name="line699">699: </a>  Mat_DSC        *lu;
<a name="line700">700: </a>  void           (*f)(void);

<a name="line703">703: </a>  <font color="#4169E1">if</font> (reuse == MAT_INITIAL_MATRIX) {
<a name="line704">704: </a>    <A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>(A,MAT_COPY_VALUES,&amp;B);
<a name="line705">705: </a>  }

<a name="line707">707: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectGetComm.html#PetscObjectGetComm">PetscObjectGetComm</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)A,&amp;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>);
<a name="line708">708: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(Mat_DSC,&amp;lu);

<a name="line710">710: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>               = A-&gt;ops-&gt;duplicate;
<a name="line711">711: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>                    = A-&gt;ops-&gt;view;
<a name="line712">712: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>             = A-&gt;ops-&gt;assemblyend;
<a name="line713">713: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactorSymbolic.html#MatCholeskyFactorSymbolic">MatCholeskyFactorSymbolic</A>  = A-&gt;ops-&gt;choleskyfactorsymbolic;
<a name="line714">714: </a>  lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>                 = A-&gt;ops-&gt;destroy;
<a name="line715">715: </a>  lu-&gt;CleanUpDSCPACK             = <A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line716">716: </a>  lu-&gt;bs                         = A-&gt;rmap.bs;
<a name="line717">717: </a>  lu-&gt;factor_type                = 0;
<a name="line718">718: </a>  lu-&gt;LBLASLevel                 = 0;
<a name="line719">719: </a>  lu-&gt;DBLASLevel                 = 0;

<a name="line721">721: </a>  B-&gt;spptr                       = (void*)lu;
<a name="line722">722: </a>  B-&gt;ops-&gt;duplicate              = MatDuplicate_DSCPACK;
<a name="line723">723: </a>  B-&gt;ops-&gt;view                   = MatView_DSCPACK;
<a name="line724">724: </a>  B-&gt;ops-&gt;assemblyend            = MatAssemblyEnd_DSCPACK;
<a name="line725">725: </a>  B-&gt;ops-&gt;choleskyfactorsymbolic = MatCholeskyFactorSymbolic_DSCPACK;
<a name="line726">726: </a>  B-&gt;ops-&gt;destroy                = MatDestroy_DSCPACK;

<a name="line728">728: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;(lu-&gt;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>));
<a name="line729">729: </a>  <font color="#4169E1">if</font> (lu-&gt;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> == 1) {
<a name="line730">730: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_seqbaij_dscpack_C"</font>,
<a name="line731">731: </a>                                             <font color="#666666">"MatConvert_BAIJ_DSCPACK"</font>,MatConvert_BAIJ_DSCPACK);
<a name="line732">732: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_dscpack_seqbaij_C"</font>,
<a name="line733">733: </a>                                             <font color="#666666">"MatConvert_DSCPACK_BAIJ"</font>,MatConvert_DSCPACK_BAIJ);
<a name="line734">734: </a>  } <font color="#4169E1">else</font> {
<a name="line735">735: </a>      <font color="#B22222">/* I really don't like needing to know the tag: MatMPIBAIJSetPreallocation_C */</font>
<a name="line736">736: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatMPIBAIJSetPreallocation_C"</font>,&amp;f);
<a name="line737">737: </a>    <font color="#4169E1">if</font> (f) {
<a name="line738">738: </a>      lu-&gt;MatPreallocate = (<A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*)(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*))f;
<a name="line739">739: </a>      <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatMPIBAIJSetPreallocation_C"</font>,
<a name="line740">740: </a>                                               <font color="#666666">"MatMPIBAIJSetPreallocation_MPIDSCPACK"</font>,
<a name="line741">741: </a>                                               MatMPIBAIJSetPreallocation_MPIDSCPACK);
<a name="line742">742: </a>    }
<a name="line743">743: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_mpibaij_dscpack_C"</font>,
<a name="line744">744: </a>                                             <font color="#666666">"MatConvert_BAIJ_DSCPACK"</font>,MatConvert_BAIJ_DSCPACK);
<a name="line745">745: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<font color="#666666">"MatConvert_dscpack_mpibaij_C"</font>,
<a name="line746">746: </a>                                             <font color="#666666">"MatConvert_DSCPACK_BAIJ"</font>,MatConvert_DSCPACK_BAIJ);
<a name="line747">747: </a>  }
<a name="line748">748: </a>  PetscObjectChangeTypeName((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)B,<A href="../../../../../../docs/manualpages/Mat/MATDSCPACK.html#MATDSCPACK">MATDSCPACK</A>);
<a name="line749">749: </a>  *newmat = B;
<a name="line750">750: </a>  <font color="#4169E1">return</font>(0);
<a name="line751">751: </a>}

<a name="line756">756: </a><strong><font color="#4169E1"><a name="MatDuplicate_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatDuplicate_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A, <A href="../../../../../../docs/manualpages/Mat/MatDuplicateOption.html#MatDuplicateOption">MatDuplicateOption</A> op, <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *M)</font></strong> {
<a name="line758">758: </a>  Mat_DSC *lu=(Mat_DSC *)A-&gt;spptr;

<a name="line761">761: </a>  (*lu-&gt;<A href="../../../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>)(A,op,M);
<a name="line762">762: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>((*M)-&gt;spptr,lu,<font color="#4169E1">sizeof</font>(Mat_DSC));
<a name="line763">763: </a>  <font color="#4169E1">return</font>(0);
<a name="line764">764: </a>}

<a name="line766">766: </a><font color="#B22222">/*MC</font>
<a name="line767">767: </a><font color="#B22222">  <A href="../../../../../../docs/manualpages/Mat/MATDSCPACK.html#MATDSCPACK">MATDSCPACK</A> - <A href="../../../../../../docs/manualpages/Mat/MATDSCPACK.html#MATDSCPACK">MATDSCPACK</A> = "dscpack" - A matrix type providing direct solvers (Cholesky) for sequential </font>
<a name="line768">768: </a><font color="#B22222">  or distributed matrices via the external package DSCPACK.</font>

<a name="line770">770: </a><font color="#B22222">  If DSCPACK is installed (see the manual for</font>
<a name="line771">771: </a><font color="#B22222">  instructions on how to declare the existence of external packages),</font>
<a name="line772">772: </a><font color="#B22222">  a matrix type can be constructed which invokes DSCPACK solvers.</font>
<a name="line773">773: </a><font color="#B22222">  After calling <A href="../../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(...,A), simply call <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(A,<A href="../../../../../../docs/manualpages/Mat/MATDSCPACK.html#MATDSCPACK">MATDSCPACK</A>).</font>
<a name="line774">774: </a><font color="#B22222">  This matrix type is only supported for double precision real.</font>

<a name="line776">776: </a><font color="#B22222">  This matrix inherits from <A href="../../../../../../docs/manualpages/Mat/MATSEQBAIJ.html#MATSEQBAIJ">MATSEQBAIJ</A> if constructed with a single process communicator,</font>
<a name="line777">777: </a><font color="#B22222">  and from <A href="../../../../../../docs/manualpages/Mat/MATMPIBAIJ.html#MATMPIBAIJ">MATMPIBAIJ</A> otherwise.  As a result, for sequential matrices, <A href="../../../../../../docs/manualpages/Mat/MatSeqBAIJSetPreallocation.html#MatSeqBAIJSetPreallocation">MatSeqBAIJSetPreallocation</A> is </font>
<a name="line778">778: </a><font color="#B22222">  supported, and similarly <A href="../../../../../../docs/manualpages/Mat/MatMPIBAIJSetPreallocation.html#MatMPIBAIJSetPreallocation">MatMPIBAIJSetPreallocation</A> is supported for distributed matrices.  It is </font>
<a name="line779">779: </a><font color="#B22222">  recommended that you call both of the above preallocation routines for simplicity.  Also,</font>
<a name="line780">780: </a><font color="#B22222">  <A href="../../../../../../docs/manualpages/Mat/MatConvert.html#MatConvert">MatConvert</A> can be called to perform inplace conversion to and from <A href="../../../../../../docs/manualpages/Mat/MATSEQBAIJ.html#MATSEQBAIJ">MATSEQBAIJ</A> or <A href="../../../../../../docs/manualpages/Mat/MATMPIBAIJ.html#MATMPIBAIJ">MATMPIBAIJ</A></font>
<a name="line781">781: </a><font color="#B22222">  for sequential or distributed matrices respectively.</font>

<a name="line783">783: </a><font color="#B22222">  Options Database Keys:</font>
<a name="line784">784: </a><font color="#B22222">+ -mat_type dscpack - sets the matrix type to dscpack during a call to <A href="../../../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>()</font>
<a name="line785">785: </a><font color="#B22222">. -mat_dscpack_order &lt;1,2,3&gt; - DSCPACK ordering, 1:ND, 2:Hybrid with Minimum Degree, 3:Hybrid with Minimum Deficiency</font>
<a name="line786">786: </a><font color="#B22222">. -mat_dscpack_scheme &lt;1,2&gt; - factorization scheme, 1:standard factorization,  2: factorization with selective inversion</font>
<a name="line787">787: </a><font color="#B22222">. -mat_dscpack_factor &lt;LLT,LDLT&gt; - the type of factorization to be performed.</font>
<a name="line788">788: </a><font color="#B22222">. -mat_dscpack_MaxMemAllowed &lt;n&gt; - the maximum memory to be used during factorization</font>
<a name="line789">789: </a><font color="#B22222">. -mat_dscpack_stats &lt;0,1&gt; - display stats of the factorization and solves during <A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(), 0: no display,  1: display</font>
<a name="line790">790: </a><font color="#B22222">. -mat_dscpack_LBLAS &lt;LBLAS1,LBLAS2,LBLAS3&gt; - BLAS level used in the local phase</font>
<a name="line791">791: </a><font color="#B22222">- -mat_dscpack_DBLAS &lt;DBLAS1,DBLAS2&gt; - BLAS level used in the distributed phase</font>

<a name="line793">793: </a><font color="#B22222">   Level: beginner</font>

<a name="line795">795: </a><font color="#B22222">.seealso: PCCHOLESKY</font>
<a name="line796">796: </a><font color="#B22222">M*/</font>

<a name="line801">801: </a><strong><font color="#4169E1"><a name="MatCreate_DSCPACK"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatCreate_DSCPACK(<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A)</font></strong>
<a name="line802">802: </a>{
<a name="line804">804: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>;

<a name="line807">807: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(A-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line808">808: </a>  <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> == 1) {
<a name="line809">809: </a>    <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(A,<A href="../../../../../../docs/manualpages/Mat/MATSEQBAIJ.html#MATSEQBAIJ">MATSEQBAIJ</A>);
<a name="line810">810: </a>  } <font color="#4169E1">else</font> {
<a name="line811">811: </a>    <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(A,<A href="../../../../../../docs/manualpages/Mat/MATMPIBAIJ.html#MATMPIBAIJ">MATMPIBAIJ</A>);
<a name="line812">812: </a>  }
<a name="line813">813: </a>  MatConvert_BAIJ_DSCPACK(A,<A href="../../../../../../docs/manualpages/Mat/MATDSCPACK.html#MATDSCPACK">MATDSCPACK</A>,MAT_REUSE_MATRIX,&amp;A);
<a name="line814">814: </a>  <font color="#4169E1">return</font>(0);
<a name="line815">815: </a>}
</pre>
</body>

</html>
